var dialog = {
    init: function(){
        this.$dialog = $('.dialog, .overlay');
        this.$dialogCreateNew = $('.dialog-create-new', this.dialog);
        this.$dialogUpload = $('.dialog-upload', this.dialog);
        this.$dialogFileSaved = $('.dialog-file-saved', this.dialog);
        this.$dialogEditAxisName = $('.dialog-edit-axis-name', this.dialog);
        //this.$dialogSaveFile = $('.dialog-save-file', this.dialog);
        //this.$dialogLoadFromStorage = $('.dialog-load-from-storage', this.dialog);
        
        this.initDialogCreateNew();
        this.initDialogUpload();
        this.initDialogFileSaved();
        this.initDialogDeleteFromStorage();
        this.initDialogEditAxisName();
        //this.initDialogSaveFile();
        //this.initDialogLoadFromStorage();
    },
    
    openDialog: function(c, params, callback){
        var self = this;
        switch (c){
            case 'dialog-create-new':
                this.$dialogCreateNew.show().siblings().hide();
                break;
            
            case 'dialog-upload':
                this.$dialogUpload.show().siblings().hide();
                break;
                
            case 'dialog-file-saved':
                this.$dialogFileSaved.show().siblings().hide();
                $('span.file-name', this.$dialogFileSaved).html(params);
                break;
                
            case 'dialog-delete-from-storage':
                this.$dialogDeleteFromStorage.show().siblings().hide();
                $('.button.confirm', this.$dialogDeleteFromStorage)
                    .data("id", params)
                    .unbind('click')
                    .click(function(){
                        callback($(this).data('id'));
                        self.closeDialog();
                    });
                break;
                
            case 'dialog-edit-axis-name':
                this.$dialogEditAxisName.show().siblings().hide();
                var $textarea = $('textarea', self.$dialogEditAxisName).attr('maxlength', params.maxlength);
                setTimeout(function(){
                    $textarea.focus().val('').val(params.name);
                }, 10);
                
                $('.button.confirm', this.$dialogEditAxisName)
                    .unbind('click')
                    .click(function(){
                        callback.saveAxisName(params.n, $textarea.val());
                        self.closeDialog();
                    });
                break;
                
            /*case 'dialog-save-file':
                this.$dialogSaveFile.show().siblings().hide();
                break;
            
            case 'dialog-load-from-storage':
                $('.notice', this.$dialogLoadFromStorage).css({'display': ((notice) ? 'block' : 'none')});
                window.lStorage.createList($('.local-storage-list', this.$dialogLoadFromStorage));
                this.$dialogLoadFromStorage.show().siblings().hide();
                break;*/
        }
        
        this.$dialog.show();
    },
    
    closeDialog: function(){
        this.$dialog.hide()
            .find('input').val('');
    },
    
    initDialogCreateNew: function(){
        var self = this,
            $btnConfirm = $('.confirm', this.$dialogCreateNew),
            $btnCancel = $('.cancel', this.$dialogCreateNew);
        
        $btnConfirm.click(function(){
            self.closeDialog();
            window.spiderWeb.openCreateNew();
        });
        
        $btnCancel.click(function(){
            self.closeDialog();
        });        
    },
    
    initDialogUpload: function(){
        var self = this,
            $btnConfirm = $('.confirm', this.$dialogUpload),
            $btnCancel = $('.cancel', this.$dialogUpload);
                    
        /*$btnConfirm.click(function(){
            window.loadGraph.load();
        });*/
        
        $btnCancel.click(function(){
            self.closeDialog();
        });        
    },
    
    initDialogFileSaved: function(){
        var self = this,
            $btnCancel = $('.cancel', this.$dialogFileSaved);
            
        $btnCancel.click(function(){
            self.closeDialog();
        }); 
    },
    
    initDialogSaveFile: function(){
        var self = this,
            $btnCancel = $('.cancel', this.$dialogSaveFile),
            $input = $('input', this.$dialogSaveFile);
            
        $btnCancel.click(function(){
            self.closeDialog();
        }); 
    },
    
    initDialogDeleteFromStorage: function(){
        this.$dialogDeleteFromStorage = $('.dialog-delete-from-storage', this.dialog);
        
        var self = this,
            $btnCancel = $('.cancel', this.$dialogDeleteFromStorage);
            
        $btnCancel.click(function(){
            self.closeDialog();
        });
    },
    
    initDialogLoadFromStorage: function(){
        var self = this,
            $btnCancel = $('.cancel', this.$dialogLoadFromStorage);
            
        $btnCancel.click(function(){
            self.closeDialog();
        });
    },
    
    initDialogEditAxisName: function(){
        var self = this,
            $btnCancel = $('.cancel', this.$dialogEditAxisName);
            
        $btnCancel.click(function(){
            self.closeDialog();
        });
        
    }
}