var loadGraph = {

    init: function(){
        var self = this;

        if (!window.lStorage.mobileDevice){
            $('a#upload-web-start, .dialog-upload a.button.confirm').click(function(){
                $('#fileInput').click();
            });
            
            this.createFileInput();
        } else {
            $('.dialog-upload a.button.confirm').click(function(){
                window.spiderWeb.showLoadGraph('webEdit');
                window.dialog.closeDialog();
            });
            
            $('a#upload-web-start').click(function(){
                window.spiderWeb.showLoadGraph('webStart');
            });
        }
        
        $('a#upload-web').click(function(){
            window.dialog.openDialog('dialog-upload');
        });
    },
    
    createFileInput: function(){
        this.fileInput = document.createElement("input");
        this.fileInput.setAttribute('type', 'file');
        this.fileInput.setAttribute('id', 'fileInput');
        this.fileInput.setAttribute('accept', 'text/xml');
        this.fileInput.className = 'hide';
        this.fileInput.addEventListener('change', this.getFileContents, false);
        document.body.appendChild(this.fileInput);
    },
    
    getFileContents: function(evt){
		if (typeof FileReader == 'undefined') {
			alert('Please update the browser.\nFileReader function is not supported.');
			return;
		}
		
        var self = this;
        var f = evt.target.files ? evt.target.files[0] : evt.srcElement; // FileList object
        if (f) {
            var r = new FileReader();
            r.onload = function(e) { 
                var contents = e.target.result;
                window.loadGraph.load(contents);
                window.loadGraph.fileInput.parentNode.removeChild(window.loadGraph.fileInput);
                window.loadGraph.createFileInput();
            }
            r.readAsText(f);
        } else { 
            alert("Failed to load file");
        }
    },
    
    load: function(data){
        var self = this;
        var d = new Date();
        
        if (this.checkFileContent(data)) {
            window.spiderWeb.clearCreatedGraphs();
            window.spiderWeb.webStartContainer.hide();
            window.spiderWeb.webLocalStorageContainer.hide();
            window.spiderWeb.webEditContainer.show();
            window.screenResize.resizeContainer();            
            
            self.parseSettings(data);
            self.parseGraphData(data);
            self.openTab(data);
            window.dialog.closeDialog();
            window.spiderWeb.addGraphBtn.toggle();
            window.spiderWeb._projectTitle.change();
            window.spiderWeb._projectAuthor.change();
        }   
    },
    
    checkFileContent: function(data){
        var settingsSucceeded = false,
            tabSucceeded = false;
            
        $('setting[id^="axis_title"]', data).each(function(n, el){
            settingsSucceeded = true;
        });
        
        $('tab', data).each(function(n, tab){
            tabSucceeded = true;
        });
        
        return (settingsSucceeded && settingsSucceeded);
    },
    
    parseSettings: function(data){
        window.spiderWeb.projectTitle = $('setting[id="title"]', data).attr('value');
        window.spiderWeb.projectAuthor = $('setting[id="author"]', data).attr('value');
        window.spiderWeb.axisCount = parseInt($('setting[id="axis_selection"]', data).attr('value'));
        window.spiderWeb.gradingCount = parseInt($('setting[id="scale_selection"]', data).attr('value'));
    
        $('setting[id^="axis_title"]', data).each(function(n, el){
            window.spiderWeb.axisNames.push(el.getAttribute('value'));
        });
        
        $('tab', data).each(function(n, tab){
            var title = $.trim(tab.getAttribute('title'));
            window.spiderWeb.graphNames.push((title == '') ? window.spiderWeb.defaultGraphName : title);
        });
        
        window.spiderWeb.graphType = parseInt($('setting[id="graph_type"]', data).attr('value'));
        
        
    },
    
    parseGraphData: function(data){
        $('tab', data).each(function(n, tab){
            var results = (tab.getAttribute('data') == null) ? [0] : tab.getAttribute('data').split(',');
            for (var r in results) results[r] = parseInt(results[r]);
            
            var data = {
                results: results,
                hidden: !(tab.getAttribute('visible') === 'true')
            };
            window.spiderWeb.createGraph(n, data);
        });
    },
    
    openTab: function(data){
        var tabNr = parseInt($('#active_tab', data).attr('value'));
        window.spiderWeb.spiderWebGraphs[tabNr].tab.hideTabs();
        window.spiderWeb.spiderWebGraphs[tabNr].tab.hideGraphs();
        window.spiderWeb.spiderWebGraphs[tabNr].tab.showTab();
    }

}