var lStorage = {
    mobileDevice: /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent),
    //mobileDevice: true,
    localStorageName: 'spiderWebStorage',
    listContainer: $(), // Set in spiderwebchoice.js - loadGraphInit()
    
    init: function(){
        var self = this;
        if (!self.mobileDevice && typeof FileReader == 'undefined') self.mobileDevice = true;
		
        self.listContainer = $('.local-storage-list', window.spiderWeb.webLocalStorageContainer);

        $('#load-from-storage').click(function(){
            self.load($('input[type="radio"]:checked', self.listContainer))
        });
        
        self.initLabels();
    },
    
    initLabels: function(){
        var self = this;
        self.listContainer.delegate('label', 'click', function(){
            self.listContainer.find('label').removeClass('selected').filter(this).addClass('selected');
        });
    },
    
    save: function(filename, data){
        var obj = {
            'filename': filename,
            'prefix': 0,
            'xml': data
        };
        
        if(
            typeof localStorage[this.localStorageName] == 'undefined' ||
            localStorage[this.localStorageName] == ''
        ){
            localStorage[this.localStorageName] = JSON.stringify([]);
        }
        
        savedArr = JSON.parse(localStorage[this.localStorageName]);
        for (var i=0, arr; arr = savedArr[i]; i++){
            if (arr.filename == obj.filename) obj.prefix = arr.prefix + 1;
        }
        savedArr.push(obj);
        localStorage[this.localStorageName] = JSON.stringify(savedArr);
        return obj;
    },
    
    load: function($el){
        var index = parseInt($el.val());
        if (isNaN(index)) return false;
        
        savedArr = JSON.parse(localStorage[this.localStorageName]);
        window.loadGraph.load(savedArr[index].xml);
    },
    
    createList: function(){
        if (
            typeof localStorage[this.localStorageName] == 'undefined' ||
            localStorage[this.localStorageName] == ''
        ) {
			$('#load-from-storage', this.webLocalStorageContainer).css({'opacity': 0.3}).addClass('disabled');
			return false;
		}
		
        savedArr = JSON.parse(localStorage[this.localStorageName]);
        var html = [];
		
        for (var i=0, arr; arr = savedArr[i]; i++){
            html.push('<tr class="input radio">');
                checked = (i == 0) ? 'checked="checked"' : null;
                selected = (i == 0) ? 'class="selected"' : null;
                html.push('<td>');
                    html.push('<input type="radio" value="'+i+'" id="loadFromStorage'+i+'" name="loadFromStorage" '+checked+'/>');
                    html.push('<label for="loadFromStorage'+i+'" '+selected+'>' + arr.filename + ((arr.prefix > 0) ? ' (' + arr.prefix + ')' : '' ) + '</label>');
                html.push('</td>');
                html.push('<td class="text-center">');
                    html.push('<a href="javascript: window.lStorage.confirmDelete('+i+')" class="trash-bin">delete</a>');
                html.push('<td>');
            html.push('</tr>');
        }
        
        this.listContainer.find('tbody').html(html.join(''));
        
        if (savedArr.length == 0){ 
            this.listContainer.siblings('.notice').show();
            $('#load-from-storage', this.webLocalStorageContainer).css({'opacity': 0.3}).addClass('disabled');
        } else { 
            this.listContainer.siblings('.notice').hide();
            $('#load-from-storage', this.webLocalStorageContainer).css({'opacity': 1}).removeClass('disabled');
        }
        return savedArr.length;
    },
    
    confirmDelete: function(n){
        window.dialog.openDialog('dialog-delete-from-storage', n, this.del);
    },
    
    del: function(n){
        var self = window.lStorage;
        if (
            typeof localStorage[self.localStorageName] == 'undefined' ||
            localStorage[self.localStorageName] == ''
        ) return false;
        
        var savedArr = JSON.parse(localStorage[self.localStorageName]),
            newArr = [];
        
        for (var i=0, arr; arr = savedArr[i]; i++){
            if (i != n)
                newArr.push(arr);
        }
        
        localStorage[self.localStorageName] = JSON.stringify(newArr);
        self.createList();
    }
}