var saveGraph = {
    filename: "",
    
    init: function(){
        this.$button = $('.save-button');
        this.initButton();
        this.createFileName();
    },
    
    initButton: function(){
        var self = this;
            /*$buttonConfirm = $('.confirm', window.dialog.$dialogSaveFile),
            $input = $('input', window.dialog.$dialogSaveFile);*/
            
        this.$button.click(function(e){
            e.preventDefault();
            
            var filename = self.createFileName('');
            
            if (!window.lStorage.mobileDevice){
                var blob = new Blob(self.collectData(), {type: "text/xml;charset=utf-8"});
                saveAs(blob, filename + ".xml");    
            } else {
                var result = window.lStorage.save(filename, self.collectData().join(''));
                filename = result.filename + ((result.prefix > 0) ? ' (' + result.prefix + ')' : '' );
                window.dialog.openDialog('dialog-file-saved', filename);
            }
            
            //window.dialog.openDialog('dialog-save-file');
            
            /*window.spiderWeb.webEditContainer.hide();
            window.spiderWeb.webPreviewContainer.show();
            window.spiderWeb.createPreviewGraph();
            window.spiderWeb.webEditContainer.show();
            window.spiderWeb.webPreviewContainer.hide();
            canvg('canvas', window.spiderWeb.spiderWebPreviewGraph.spiderWeb.innerHTML,{ ignoreDimensions: true, offsetX: -30 });
            document.getElementById('canvas').toBlob(function(blob) {
                saveAs(blob, filename + ".png");
            });*/
        });
        
        /*
        $input.keyup(function(e){
            if (e.keyCode == 13) $buttonConfirm.click();
        });
        
        $buttonConfirm.click(function(e){
            e.preventDefault();
            var filename = self.createFileName($input.val());
            
            if (!window.lStorage.mobileDevice){
                var blob = new Blob(self.collectData(), {type: "text/xml;charset=utf-8"});
                saveAs(blob, filename + ".xml");    
            } else {
                window.lStorage.save(filename, self.collectData().join(''));
            }
            
            window.dialog.closeDialog();
        });
        */
    },
    
    createFileName: function(value){
        if ($.trim(value) != '') return value;
        
        var d = new Date(),
            filename = this.filename + d.getFullYear() +'-'+ ((d.getMonth() < 9) ? ('0' + (d.getMonth()+1)): d.getMonth()+1) +'-'+ d.getDate() +' '+ d.getHours() +":"+ d.getMinutes();
            
        return filename;
    },
    
    collectData: function(){
        spiderWeb = window.spiderWeb;
        var data = [],
            settings = [],
            tabs = [];
        
        settings.push('<settings>');
        
        tabs_in_use = '<setting id="tabs_in_use" value="';
        for (var i in spiderWeb.spiderWebGraphs)
            tabs_in_use += ((i != 0) ? ',' : '') + i
        tabs_in_use += '"/>';
        settings.push(tabs_in_use);
        
        settings.push('<setting id="graph_type" value="'+ spiderWeb.graphType +'"/>');
        settings.push('<setting id="active_tab" value="'+ spiderWeb.activeTab +'"/>');
        settings.push('<setting id="axis_selection" value="'+ spiderWeb.axisCount +'"/>');
        settings.push('<setting id="scale_selection" value="'+ spiderWeb.gradingCount +'"/>');
        settings.push('<setting id="tab_count" value="'+ spiderWeb.spiderWebGraphs.length +'"/>');
        settings.push('<setting id="title" value="'+ spiderWeb.projectTitle +'"/>');
        settings.push('<setting id="author" value="'+ spiderWeb.projectAuthor +'"/>');
        
        for (var axis in spiderWeb.axisNames)
            settings.push('<setting id="axis_title_'+ axis +'" value="'+ spiderWeb.axisNames[axis] +'"/>');
            
        settings.push('</settings>');
        
        tabs.push('<tabs>');        
        for (var tab in spiderWeb.spiderWebGraphs)
            tabs.push('<tab id="'+ tab +'" title="'+ spiderWeb.graphNames[tab] +'" visible="'+ (!spiderWeb.spiderWebGraphs[tab].hidden) +'" data="'+ spiderWeb.spiderWebGraphs[tab].results.join(',') +'"/>');
        tabs.push('</tabs>');        
        
        return data.concat(['<data id="voratinklis">'], settings, tabs, ['</data>']);
    }
    
}