var screenResize = {
    resizeTimeout: null,
    containerHeight: 0,
    
    init: function(){
        var self = this;
        
        self.$dialog = $('.dialog');
        
        $(window).resize(function(){
            self.resizeContainer();
            
            if (self.resizeTimeout != null)
                clearTimeout(self.resizeTimeout);
            
            self.resizeTimeout = setTimeout(function(){
                self.resizeGraph();
                self.adjustDialog();
            },500);
        }).triggerHandler('resize');
    },
    
    resizeContainer: function(){
        var self = this;
        $('.spiderweb-box:visible').each(function(){
            var $c = $(this).css({'min-height': '0', 'height': '0'}),
                parentHeight = $c.parent().height(),
                siblings = $c.siblings(),
                siblingsHeight = 0,
                inputVisible = ($('input[type="text"]', $c).css('display') == 'block');
                
            if (inputVisible) { 
                $c.css({'min-height': self.containerHeight + 'px', 'height': '100%'});
                return;
            }
                
            $.each(siblings, function(){
                siblingsHeight = siblingsHeight + $(this).height();
            });
                
            self.containerHeight = (parentHeight - siblingsHeight - 8);
            $c.css({'min-height': self.containerHeight + 'px', 'height': '100%'});
        });
    },
    
    resizeGraph: function(){
        window.spiderWeb.adjustToScreen();
    },
    
    adjustDialog: function(){
        
        var margin = 0,
            windowHeight = $(window).height(),
            dialogHeight = this.$dialog.outerHeight(),
            top = (windowHeight - dialogHeight) / 2;
            
            this.$dialog.animate({'top': (top < 0) ? 0 : top + 'px'});
    }
}