function Tab(n){
    this.construct();
    
    this.tabNr = n;
    this.spiderWeb = window.spiderWeb.spiderWebGraphs[this.tabNr].spiderWeb;
    
    //console.log(window.spiderWeb.spiderWebGraphs[this.tabNr]);
    
    this.createTab = function(){
        var graphName = (window.spiderWeb.graphNames[this.tabNr]) ? window.spiderWeb.graphNames[this.tabNr] : window.spiderWeb.defaultGraphName;
        
        this.tab = document.createElement("li");
        
        this.link = document.createElement("a");
        this.link.href = "javascript:void(0)";
        //this.link.title = graphName;
        this.link.style.borderColor = window.spiderWeb.spiderWebGraphs[this.tabNr].graphColor;
        this.link.style.color = window.spiderWeb.spiderWebGraphs[this.tabNr].fontColor;
        
        this.graphName = document.createElement("span");
        this.graphName.className = "text";
        this.graphName.innerHTML = graphName;
        
        this.shadow = document.createElement("span");
        this.shadow.className = "shadow";
        
        this.deleteBtn = document.createElement("span");
        this.deleteBtn.className = "delete";
        
        this.graphNameEditor = document.createElement("input");
        this.graphNameEditor.type = "text";
        this.graphNameEditor.style.color = window.spiderWeb.spiderWebGraphs[this.tabNr].fontColor;
                
        this.link.appendChild(this.graphName);
        this.link.appendChild(this.shadow);
        this.link.appendChild(this.deleteBtn);
        this.link.appendChild(this.graphNameEditor);
        this.tab.appendChild(this.link);
        
        this.tabHolder.insertBefore(this.tab, this.addGraphBtn);
    };
    
    this.hideTabs = function(){
        for (var i=0; i < this.tabHolder.children.length; i++)
            if (typeof this.tabHolder.children[i] == 'object' && this.tabHolder.children[i].getAttribute('id') != "dd-graph")
                this.tabHolder.children[i].removeAttribute('class');
    };
    
    this.hideGraphs = function(){
        var children = this.spiderWeb.parentNode.children;
        for (var i=0; i<children.length; i++)
            children[i].setAttribute('class', 'hide');
    };
    
    this.initTab = function(){
        var self = this;
        this.link.addEventListener('click', function(e){
            if (e.target != self.deleteBtn){
                self.hideTabs();
                self.hideGraphs();
                self.showTab();
                window.spiderWeb.spiderWebGraphs[self.tabNr].redrawGraph();
            }
        });
        
        this.graphName.addEventListener('click', function(){
            if ( self.tab.className == 'active' ){
                self.graphNameEditor.style.display = 'block';
                self.graphNameEditor.value = (window.spiderWeb.defaultGraphName == window.spiderWeb.graphNames[self.tabNr]) ? '' : window.spiderWeb.graphNames[self.tabNr];
                self.graphNameEditor.focus();
            }
        });
        
        this.graphNameEditor.addEventListener("keyup", function(e){
            if (e.keyCode == 13)
                self.graphNameEditor.blur();
        });
        
        this.graphNameEditor.onblur = function(){
            var defaultName = (self.graphNameEditor.value.match(/\S/) == null);
            window.spiderWeb.graphNames[self.tabNr] = (defaultName) ? window.spiderWeb.defaultGraphName : self.graphNameEditor.value;
            this.style.display = "none";
            self.graphName.innerHTML = window.spiderWeb.graphNames[self.tabNr];
        };
    };
    
    this.initDelete = function(){
        var self = this;
        this.deleteBtn.addEventListener('click', function(){
            window.spiderWeb.deleteGraph(self.tabNr);
        });
    };
    
    this.showTab = function(){
        window.spiderWeb.activeTab = this.tabNr;
        this.deleteBtn.style.display = (this.tabHolder.children.length > 2) ? "block" : "none";
        this.tab.setAttribute('class', 'active');
        this.spiderWeb.removeAttribute('class');
        this.spiderWeb.parentNode.style.borderColor = window.spiderWeb.spiderWebGraphs[this.tabNr].graphColor;
        
        //window.spiderWeb.spiderWebGraphs[this.tabNr].getContainerDimensions();
        //window.spiderWeb.spiderWebGraphs[this.tabNr].resizeGraph();
    };
        
    this.hideTabs();
    this.hideGraphs();
    
    this.createTab();
    this.showTab();
    this.initTab();
    this.initDelete();
    
    return this;
}

Tab.prototype.construct = function(){
    this.tabHolder = document.getElementById('graphTabs');
    this.addGraphBtn = document.getElementById('add-graph');
}